<div
  class="m-comments__thread"
  commentsScroll
  (previous)="autoloadPrevious()"
  [emitter]="commentsScrollEmitter"
  [enabled]="scrollable"
  #scrollArea
>
  <div
    class="mdl-color-text--blue-grey-500 m-comments-load-more"
    (click)="load(false, 'desc')"
    [ngClass]="{ 'm-disabled': inProgress }"
    *ngIf="loadPrevious"
  >
    <span *ngIf="descendingInProgress">
      <i class="material-icons">autorenew</i>
      <ng-container i18n="@@MINDS__COMMENTS__LOADING_ELLIPSIS"
        >Loading&hellip;</ng-container
      >
    </span>
    <span *ngIf="!descendingInProgress && !loaded">
      <i class="material-icons">update</i>
      <ng-container *ngIf="!error"
        ><ng-container i18n="@@MINDS__COMMENTS__LOAD_ACTION"
          >Load</ng-container
        ></ng-container
      >
      <ng-container *ngIf="error"
        ><ng-container i18n="@@MINDS__COMMENTS__TRY_AGAIN_ACTION"
          >Try again</ng-container
        ></ng-container
      >
    </span>
    <span *ngIf="!descendingInProgress && loaded">
      <i class="material-icons">update</i>
      <ng-container i18n="@@MINDS__COMMENTS__LOAD_EARLIER_ACTION"
        >Load earlier</ng-container
      >
    </span>
  </div>

  <p
    class="m-comments--start-conversation-label"
    *ngIf="
      !inProgress &&
      !error &&
      comments?.length === 0 &&
      parent.type == 'activity'
    "
    i18n="@@MINDS__COMMENTS__START_CONVERSATION"
  >
    Start the conversation!
  </p>

  <p class="m-comments--load-error-label" *ngIf="!inProgress && !!error">
    <i class="material-icons">warning</i>
    <span>{{ error }}</span>
  </p>

  <p class="m-commentsThread__blockedComment" *ngIf="isThreadBlocked()" i18n>
    This thread contains replies from blocked channels.
  </p>

  <div class="m-layout--spacer"></div>
  <ng-container *ngFor="let comment of getComments(); let i = index">
    <m-comment
      [comment]="comment"
      [entity]="entity"
      [parent]="parent"
      [level]="level"
      [canEdit]="canEdit"
      [canDelete]="canDelete"
      [showReplies]="comment.show_replies"
      (delete)="delete(i)"
      (saved)="edited(i, $event)"
      (onReply)="reply($event.comment)"
    ></m-comment>
  </ng-container>

  <div
    class="mdl-color-text--blue-grey-500 m-comments-load-more"
    (click)="load(false, 'asc')"
    [ngClass]="{ 'm-disabled': ascendingInProgress }"
    *ngIf="loadNext"
  >
    <span *ngIf="ascendingInProgress">
      <i class="material-icons">autorenew</i>
      <ng-container i18n="@@MINDS__COMMENTS__LOADING_ELLIPSIS"
        >Loading&hellip;</ng-container
      >
    </span>
    <span *ngIf="!ascendingInProgress && !loaded">
      <i class="material-icons">update</i>
      <ng-container *ngIf="!error"
        ><ng-container i18n="@@MINDS__COMMENTS__LOAD_ACTION"
          >Load</ng-container
        ></ng-container
      >
      <ng-container *ngIf="error"
        ><ng-container i18n="@@MINDS__COMMENTS__TRY_AGAIN_ACTION"
          >Try again</ng-container
        ></ng-container
      >
    </span>
    <span *ngIf="!ascendingInProgress && loaded">
      <i class="material-icons">update</i>
      <ng-container i18n="@@MINDS__COMMENTS__LOAD_EARLIER_ACTION"
        >Load later</ng-container
      >
    </span>
  </div>
</div>

<m-comment__poster
  [guid]="guid"
  [parent]="parent"
  [entity]="entity"
  [currentIndex]="comments.length - 1"
  [conversation]="conversation"
  (posted)="onPosted($event)"
  (optimisticPost)="onOptimisticPost($event)"
>
</m-comment__poster>
